package com.socialmine.mergedservices;




import android.content.ContentValues;
import android.content.Context;
import android.database.Cursor;
import android.database.SQLException;
import android.database.sqlite.SQLiteDatabase;
import android.database.sqlite.SQLiteOpenHelper;
import android.util.Log;

public class DBGeolocationService {

    public static final String KEY_ROWID = "_id";
       public static final String KEY_LATITUDE = "Latitude";
       public static final String KEY_LONGITUDE = "Longitude";
       public static final String KEY_LOCTIME = "LocTime";
       public static final String KEY_ISSEND = "IsSend";
       private static final String TAG = "DBAdapter";
       
       private static final String DATABASE_NAME = "userdata";
       private static final String DATABASE_TABLE = "GeoLoc";
       private static final int DATABASE_VERSION = 2;

       private static final String DATABASE_CREATE =
           "create table GeoLoc (_id integer primary key autoincrement, "
           + "Latitude double not null, Longitude double not null, " 
           + "LocTime text not null, IsSend text not null);";
       
       
           
           
           
       private final Context context;  

       private DatabaseHelper DBHelper;
       private static SQLiteDatabase db;

       public DBGeolocationService(Context ctx) 
       {
           this.context = ctx;
           DBHelper = new DatabaseHelper(context);
       }
           
       private static class DatabaseHelper extends SQLiteOpenHelper 
       {
           DatabaseHelper(Context context) 
           {
               super(context, DATABASE_NAME, null, DATABASE_VERSION);
           }

           @Override
           public void onCreate(SQLiteDatabase db) 
           {
               db.execSQL(DATABASE_CREATE);
           }

           @Override
           public void onUpgrade(SQLiteDatabase db, int oldVersion, 
                                 int newVersion) 
           {
               Log.w(TAG, "Upgrading database from version " + oldVersion 
                     + " to "
                     + newVersion + ", which will destroy all old data");
               db.execSQL("DROP TABLE IF EXISTS titles");
               onCreate(db);
           }
       }    

       //---opens the database---
       public DBGeolocationService open() throws SQLException 
       {
           db = DBHelper.getWritableDatabase();
           return this;
       }

       //---closes the database---    
       public void close() 
       {
           DBHelper.close();
       }
       
       //---insert a new location into the database---
       public long insertLocation(double latitude, double longitude, String loctime) 
       {
           ContentValues initialValues = new ContentValues();
           initialValues.put(KEY_LATITUDE, latitude);
           initialValues.put(KEY_LONGITUDE, longitude);
           initialValues.put(KEY_LOCTIME, loctime);
           initialValues.put(KEY_ISSEND, "False");
           return db.insert(DATABASE_TABLE, null, initialValues);
       }
       

       //---retrieves all the locations---
       public static Cursor getAllLocations() 
       {
           return db.query(DATABASE_TABLE, new String[] {
                 KEY_ROWID, 
                 KEY_LATITUDE,
                 KEY_LONGITUDE,
                   KEY_LOCTIME
                   }, 
                   "IsSend = 'False'", 
                   null, 
                   null, 
                   null, 
                   null,
                   null);
       }
       
       
       //---delete all the locations---
       public static void updateSend()
       {
    	   
    	   String sql = "UPDATE GeoLoc SET IsSend = 'True' WHERE IsSend = 'False'";
    	   db.execSQL(sql);
       }
       


       
       
}