package com.socialmine.mergedservices;


import java.text.SimpleDateFormat;
import java.util.Date;
import android.app.Service;
import android.content.Intent;
import android.database.Cursor;
import android.os.IBinder;
import android.provider.CallLog;
import android.provider.CallLog.Calls;
import android.util.Log;



public class PhoneService extends Service	{
	

			//////////////////// Declaration of variables //////////////////////

			// Declare database + Log-tag
			private static final String TAG = PhoneService.class.getSimpleName();
			public DBPhoneService callLogs;

			// Declare all values, which need to be logged
			String date, time, name, phonenumber, duration, callclassification;

			// Declare temporary variables (place-holders)
			String tmp1;
			int tmp2;

			
			//////////////////// Formatting Methods of time/date/duration/call-type //////////////////////


			// Specify formatting of data and time --> looks awesome now :D
			SimpleDateFormat formatdate = new SimpleDateFormat("dd-MM-yyyy");
			SimpleDateFormat formattime = new SimpleDateFormat("HH:mm:ss");


			// Specify formatting for duration --> looks even more awesome :D    
			public String formatDuration(String input) {
    
				long seconds = Long.parseLong(input);
				StringBuffer buf = new StringBuffer();

				int h = (int) Math.floor(seconds / 3600);
				int m = (int) Math.floor((seconds - h * 3600) / 60);
				int s = (int) seconds - h - m;

				buf
					.append(String.format("%02d", h))
					.append(":")
					.append(String.format("%02d", m))
					.append(":")
					.append(String.format("%02d", s));

				return buf.toString();
			}

			// Specify interpretation of Call-Type
			public String callType(int t)    {
    
				String g = null;

				switch(t)	{
					case Calls.INCOMING_TYPE: 
						g = "Incoming Call";
						break;
					case Calls.OUTGOING_TYPE: 
						g = "Outgoing Call";
						break;
					case Calls.MISSED_TYPE: 
						g = "Missed Call";
						break;	
				}
				return g;
    
			}


			@Override
			public IBinder onBind(Intent intent) {
				return null;
			}

		
			@Override
			public void onCreate() {
				super.onCreate();
			}

			
			//////////////////// Actual Functionality of the whole PhoneService: Logs Collection + Storage //////////////////////


			public int onStartCommand (Intent intent, int flags, int startId)	{
	
	
				Log.d(TAG, "Log Collection is activated");
		
				// Create Database
				
				callLogs = new DBPhoneService(getBaseContext());	
	
	
				// Collect new Phone Logs //
	  
				Cursor c = getContentResolver().query(
	               android.provider.CallLog.Calls.CONTENT_URI,
	               null,
	               null,
	               null,
	               android.provider.CallLog.Calls.DATE+ " DESC");
				c.moveToFirst();
 	   
 	
				date = formatdate.format(new Date());
				time = formattime.format(new Date()); 
				name = c.getString(c.getColumnIndex(CallLog.Calls.CACHED_NAME));
				phonenumber = c.getString(c.getColumnIndex(CallLog.Calls.NUMBER));
				tmp1 = c.getString(c.getColumnIndex(CallLog.Calls.DURATION));
				duration = formatDuration(tmp1);
				tmp2 = c.getInt(c.getColumnIndex(CallLog.Calls.TYPE));
				callclassification = callType(tmp2);
 	
				c.close();
	 
				// Log new Phone Logs
 	
				Log.d(TAG, date);
				Log.d(TAG, time);
				Log.d(TAG, name);
				Log.d(TAG, phonenumber);
				Log.d(TAG, duration);
				Log.d(TAG, callclassification);
	  			    
	  
				// Write new Phone Logs in Database //
  	
				callLogs.open();
				callLogs.insertCallLogs(date, time, name, phonenumber, duration, callclassification);
				callLogs.close();
	

	
				return startId;
				
			}
	


	
	
}