package com.socialmine.mergedservices;


import android.app.Activity;
import android.app.AlarmManager;
import android.app.PendingIntent;
import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.os.SystemClock;
import android.telephony.PhoneStateListener;
import android.telephony.TelephonyManager;
import android.util.Log;



public class PhoneServiceReceiver extends BroadcastReceiver {
	
	private static final String TAG = PhoneServiceReceiver.class.getSimpleName();
    public TelephonyManager telephony;
	public MyPhoneStateListener phoneListener;
	public Context cName;




    @Override
    public void onReceive(Context context, Intent intent) 
    {
    	cName = context;

		// Put a Listener on the Phone-State

			telephony = (TelephonyManager) context.getSystemService(Context.TELEPHONY_SERVICE);
			phoneListener = new MyPhoneStateListener();
			telephony.listen(phoneListener,PhoneStateListener.LISTEN_CALL_STATE);
			Log.d(TAG, "Listener created");


     
    }
    
    
	//////// Private Class MyPhoneStateListener /////////
	
	private class MyPhoneStateListener extends PhoneStateListener {
		

  		
		 public void onCallStateChanged(int state,String incomingNumber){
			  

		  	Log.d(TAG, "STATE HAS CHANGED!");

			switch(state)	{
			  	case TelephonyManager.CALL_STATE_IDLE:
			  		Log.d(TAG, "Phone is inactive - IDLE state");
			  		
                    // Here comes the actual Service-Functionality
                    
                    Intent pService = new Intent();
                    pService.setAction("com.socialmine.mergedservices.PhoneService");

                    int sleep = 5000; // Waiting time before Log-database is accessed
                    
                    PendingIntent piSync = PendingIntent.getService(cName, 0, pService, 0);
                    Log.i(TAG, "schedulePendingSync: " + piSync.toString());
                    AlarmManager alarm = (AlarmManager) cName.getSystemService(Activity.ALARM_SERVICE);
                    alarm.set(AlarmManager.ELAPSED_REALTIME, SystemClock.elapsedRealtime() + sleep, piSync);
                    
                    // End of Service-Functionality
		    		killListener();

			  		break;
			  	case TelephonyManager.CALL_STATE_OFFHOOK:
			  		Log.d(TAG, "Initiated/Accepted Call");
		    		killListener();
			  		break;
			  	case TelephonyManager.CALL_STATE_RINGING:
		    		Log.d(TAG, "RINGING");
		    		killListener();
			  		break;
			  }
						  
			  
		  }


	}
	
	public void killListener()	{
		
		// Kill this Listener-Instance --> make room for new instance
		telephony = null;
		phoneListener = null;
		Log.d(TAG, "Killed Listener");
		
	}


	
}